# coding: utf-8

"""
    FINBOURNE Scheduler API

    FINBOURNE Technology  # noqa: E501

    Contact: info@finbourne.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from typing import Any, Dict, Optional
from pydantic import BaseModel, Field, StrictBool, StrictStr

class Tag(BaseModel):
    """
    Represents data of an image's tag  # noqa: E501
    """
    name: Optional[StrictStr] = Field(None, description="The name of the tag")
    pull_time: Optional[datetime] = Field(None, alias="pullTime", description="The latest pull time")
    push_time: Optional[datetime] = Field(None, alias="pushTime", description="The date of the tag's push")
    signed: Optional[StrictBool] = Field(None, description="Indicates whether the tag is signed")
    immutable: Optional[StrictBool] = Field(None, description="Indicates whether the tag is immutable")
    __properties = ["name", "pullTime", "pushTime", "signed", "immutable"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Tag:
        """Create an instance of Tag from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # set to None if name (nullable) is None
        # and __fields_set__ contains the field
        if self.name is None and "name" in self.__fields_set__:
            _dict['name'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> Tag:
        """Create an instance of Tag from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return Tag.parse_obj(obj)

        _obj = Tag.parse_obj({
            "name": obj.get("name"),
            "pull_time": obj.get("pullTime"),
            "push_time": obj.get("pushTime"),
            "signed": obj.get("signed"),
            "immutable": obj.get("immutable")
        })
        return _obj
